#include <SDL.h>

#include <math.h>

#include "arrow.h"
#include "control.h"
#include "controlmanager.h"
#include "mouse.h"
#include "actormanager.h"
#include "imagearrow.h"


void Arrow::init()
{
	layer=3;

	is_charging=false;
	power=MIN_POWER;
	ag=new ImageArrow(this,"arrow.png");
	ag->init();
}

void Arrow::desactivate()
{
	ag->desactivate();
	is_charging=false;
	power=MIN_POWER;
}

void Arrow::move()
{
	//Si se esta cargando
	if(is_charging!=false)
	{
		power+=is_charging;
		arrow=normalize(arrow);
		arrow=multiply(arrow,power);

		//Comprobamos que si ha llegado a los topes
		if(power<MIN_POWER || power>MAX_POWER)
			is_charging=-is_charging;
	}
	r=ag->get_w()/2;
}

void Arrow::setDir(Vector &dir)
{
	arrow=normalize(dir);
	arrow=multiply(arrow,power);
}
