#ifndef ARROW_H
#define ARROW_H

#include <SDL.h>
#include <math.h>

#include "controllable.h"
#include "circularactor.h"
#include "imagearrow.h"
#include "control.h"
#include "cap.h"

#include "timer.h"

#define MIN_POWER 0.2
#define MAX_POWER 0.9

class Arrow : public CircularActor
{
	public:
		Arrow():CircularActor(){}
		Arrow(zero_t):CircularActor(zero){}

     // SDL_Rect getGraphicRect()const{return (SDL_Rect){(int)(center.scale_x()-ag->get_w()/2),(int)(center.scale_y()-ag->get_h()/2),ag->get_w(),ag->get_h()};}

		SDL_Rect getGraphicRect()const{return ag->getRect();}
		void init();
		void desactivate();
		void move();

		//Devuelve la potencia
		float getPower()const{return power+0.1;}
		float getAngRad()const{return atan2(-arrow.scale_y(),arrow.scale_x());}
		float getAng()const{return 180*atan2(-arrow.scale_y(),arrow.scale_x())/M_PI;}

		Vector getArrow()const{return arrow;}

		void setDir(Vector &dir);
		void setCap(Cap *c){((ImageArrow*)ag)->setCap(c);}

		void charge(){is_charging=0.02;}
		void doAction(Controllable::action_t act,int magnitude);

	protected:
		float is_charging;
		float power;
		Vector arrow;
};

#endif
