#include "arrowmenu.h"
#include "specialimage.h"

void ArrowMenu::init()
{
	noactive=new SpecialImage(this,"menuimg/noactive.png");
	active=new SpecialImage(this,"menuimg/active.png");
	click=new SpecialImage(this,"menuimg/click.png");
	noactive->init();
	active->init();
	click->init();
	if(type==RIGHT)
	{
		noactive->flip();
		active->flip();
		click->flip();
	}
	ag=noactive;
	layer=2;
	priority=2;
	r=ag->get_w()/2;
}

void ArrowMenu::getMouseSignal(mousesignal_t s)
{
	if(s==ON_MOUSEOVER)
	{
		ag->desactivate();
		ag=active;
		ag->activate();
		el->getSignal(MenuElement::SELECTED);
	}
	else if(s==CLICKED)
	{
		ag->desactivate();
		ag=click;
		ag->activate();
	}
	else if(s==ON_MOUSEOUT)
	{
		ag->desactivate();
		ag=noactive;
		ag->activate();
		el->getSignal(MenuElement::UNSELECTED);
	}
	else if(s==UNCLICKED)
	{
		ag->desactivate();
		ag=active;
		ag->activate();
		if(type==LEFT)
			el->getSignal(MenuElement::PRESS_LEFT);
		else
			el->getSignal(MenuElement::PRESS_RIGHT);
	}
}
