#ifndef ARROWMENU_H
#define ARROWMENU_H

#include "menumouseelement.h"
#include "circularactor.h"
#include "collision.h"
#include "image.h"
#include "menuelement.h"

class ArrowMenu : public CircularActor, public MenuMouseElement
{
	public:
		typedef enum 
		{
			LEFT,
			RIGHT
		}arrowmenu_t;

		ArrowMenu(arrowmenu_t t):CircularActor(zero),MenuMouseElement(zero),type(t){}
		~ArrowMenu(){}

		void init();
		void getMouseSignal(mousesignal_t s);
		void setElement(MenuElement *e){el=e;}
		bool isHere(Vector &v){return isCollision(v,this)!=NO_COLLISION;}

	protected:
		arrowmenu_t type;
		Image* noactive;
		Image* active;
		Image* click;
		MenuElement *el;
};

#endif
