#include <SDL.h>
#include <SDL_rotozoom.h>

#include <string>

using namespace std;

#include "capimage.h"
#include "utils.h"
#include "rendermanager.h"
#include "actor.h"

void CapImage::init()
{
	img=LoadImgAlpha(name);
	orig=LoadImgAlpha(name);
	center=owner->getCenter();
}

void CapImage::update()
{
	if(center!=owner->getCenter() || change)
	{
		//Poner el fondo donde estaba antes
		g->rendermanager->addToDraw(rect);

		center=owner->getCenter();
		rect=owner->getGraphicRect();
		change=false;

		//Poner el fondo donde va a estar ahora
		g->rendermanager->addToDraw(rect);
	}
}

void CapImage::rotate(float ang)
{
	SDL_FreeSurface(img);
	img=rotozoomSurface(orig,ang,1,SMOOTHING_ON);
	change=true;
}
