#include "choosestadium.h"
#include "actormanager.h"

#include <iostream>
#include <fstream>
#include <sys/stat.h>
#include <dirent.h>

#define THEMES_DIR "themes/"

void ChooseStadium::init()
{
	Preview::setGame(g);
	actual=0;

	DIR* pdir;
   struct stat st; // Permisos y Otros parámetros
   struct dirent *dp;

   pdir=opendir(THEMES_DIR);
   if(pdir==NULL)
   {
      printf("Error abriendo el directorio: %s\n",THEMES_DIR);
      exit(-1);
   }
	
   while((dp=readdir(pdir))!=NULL)
   {
		string dir_name=THEMES_DIR;
		dir_name=dir_name+dp->d_name;
		//Nos saltamos todo lo que empiece por punto
		if(strncmp(dp->d_name,".",1)==0)
			continue;

      if(stat(dir_name.c_str(), &st) < 0 )
		{
			perror(dp->d_name);
			exit(-1);
		}
      else
      {  
			//Si es un directorio lo analizamos
			if(S_ISDIR(st.st_mode))
			{	
				Preview *p=new Preview();
				p->init(dir_name);
				prevs.push_back(p);
			}
		}
	}
	closedir(pdir);

	if(prevs.size()>0)
	{
		prevs[actual]->activate();
		setText(prevs[actual]->getDir());
	}
	else
	{
		cerr<<"No se ha detectado ningun tema"<<endl;
		exit(-1);
	}

	MenuText::init();
}

void ChooseStadium::goStadium()
{
	chdir(prevs[actual]->getDir());
}

void ChooseStadium::shutdown()
{
	for(unsigned i=0;i<prevs.size();i++)
	{
		prevs[i]->shutdown();
		delete (prevs[i]);
	}
	prevs.clear();
}

void ChooseStadium::getSignal(signal_t s)
{
	MenuText::getSignal(s);

	if(s==PRESS_LEFT)
		previousTheme();
	else if(s==PRESS_RIGHT)
		nextTheme();
}
void ChooseStadium::nextTheme()
{
	prevs[actual]->desactivate();
	actual++;
	if(actual==prevs.size())
		actual=0;

	prevs[actual]->activate();
	setText(prevs[actual]->getDir());
}

void ChooseStadium::previousTheme()
{
	prevs[actual]->desactivate();
	if(actual==0)
		actual=prevs.size()-1;
	else
		actual--;

	prevs[actual]->activate();
	setText(prevs[actual]->getDir());
}
