#ifndef HUMANMANAGER_H
#define HUMANMANAGER_H

#include "controllable.h"
#include "game.h"
#include "arrow.h"
#include "activecap.h"
#include "teammanager.h"
#include "cap.h"
#include "control.h"


//Clase que controla a un equipo a traves del raton
//Funciona como una maquina de estados que se modifican
//segun los clicks del raton del usuario
class HumanManager : public Controllable, public TeamManager
{
	public:
		HumanManager();
		~HumanManager();
		
		void init(Game::team_t t);
		void update(){}
		void shutdown();
		void stop();

		typedef enum
		{
			CLICK,
			UNCLICK,
			MOVE_X,
			MOVE_Y,
			EXIT
		}action_t;

		void doAction(Controllable::action_t action,int magnitude);
		void throws(){s=WAIT;}
		bool isOver(){return s==END;}

		void oneMore(Cap *c);

	private:
		//Tenemos una instancia flecha que se encarga de la direccion 
		//y la potencia del disparo
		Arrow *vel_arrow;
		Arrow *accel_arrow;
		ActiveCap *ac;

		enum states_t
		{
			WAIT,
			SELECTED,
			C_ARROW,
			END
		};

		states_t s;

		bool onemore;
		Control *controller;
};

#endif
