#include <SDL.h>
#include <SDL_image.h>
#include <SDL_rotozoom.h>

#include "imagearrow.h"
#include "utils.h"
#include "rendermanager.h"
#include "arrow.h"

void ImageArrow::init()
{
	arrow=(Arrow*)owner;
	orig=LoadImgAlpha(name);
	img=LoadImgAlpha(name);
}

void ImageArrow::active()
{
	update();
}

void ImageArrow::update()
{
	//Con numeros negativos no funciona bien por eso creamos 
	//un rectangulo que pasamos pero sin numeros negativos.
	//Le pasamos el rectangulo donde estabamos antes para que lo rellene
	//con el fondo de pantalla y la flecha no deje rastro
	g->rendermanager->addToDraw(rect);

	SDL_FreeSurface(img);

	SDL_Surface* tmp=rotozoomSurfaceXY(orig,0,arrow->getPower(),1,SMOOTHING_ON);
	Vector center=Vector(cap->getRadio()+tmp->w/2,0);
	center=Vector(center.module()*cos(arrow->getAngRad()),center.module()*-sin(arrow->getAngRad()));
	center=center+cap->getPos();

	img=rotozoomSurface(tmp,(arrow->getAng()),1,SMOOTHING_ON);
	SDL_FreeSurface(tmp);

	rect.x=(int)(center.scale_x()-img->w/2);
	rect.y=(int)(center.scale_y()-img->h/2);
	rect.w=img->w;
	rect.h=img->h;
	
	//rect=owner->getGraphicRect();
	//printf("%d %d %u %u \n",rect.x,rect.y,rect.w,rect.h);

	g->rendermanager->addToDraw(rect);
}

void ImageArrow::desactive()
{
	g->rendermanager->addToDraw(rect);
}

void ImageArrow::draw()
{
	//Si le pasamos numeros negativos te los devuelve como cero por eso le
	//pasamos uno que es temporal
	SDL_Rect r=rect;
	SDL_BlitSurface(img,NULL,SDL_GetVideoSurface(),&r);
}
