#include "menuchapping.h"
#include "rendermanager.h"
#include "actormanager.h"

void MenuChapping::load()
{
	logo=new Logo();
	logo->init();
	g->actormanager->activate(logo);

	start=new StartText(zero);
	start->setText("Start Game");
	start->setPos(362,400);
	start->setSize(300,32);
	start->setMenu(this);
	start->init();
	start->setLayer(2);

	full=new Fullscreen(zero);
	full->setTextNo("Fullscreen: NO");
	full->setTextYes("Fullscreen: YES");
	full->setPos(362,442);
	full->setSize(300,32);
	full->setLayer(2);
	full->init();

	rightfull=new ArrowMenu(ArrowMenu::RIGHT);
	rightfull->init();
	rightfull->setElement(full);
	rightfull->setPos(692,458);
	
	leftfull=new ArrowMenu(ArrowMenu::LEFT);
	leftfull->init();
	leftfull->setElement(full);
	leftfull->setPos(332,458);

	choose=new ChooseStadium(zero);
	choose->setGame(g);
	choose->setPos(362,484);
	choose->setSize(300,32);
	choose->setLayer(2);
	choose->init();

	rightstadium=new ArrowMenu(ArrowMenu::RIGHT);
	rightstadium->init();
	rightstadium->setElement(choose);
	rightstadium->setPos(692,500);
	
	leftstadium=new ArrowMenu(ArrowMenu::LEFT);
	leftstadium->init();
	leftstadium->setElement(choose);
	leftstadium->setPos(332,500);

	about=new AboutText(zero);
	about->setText("About");
	about->setPos(362,526);
	about->setSize(300,32);
	about->setMenu(this);
	about->init();
	about->setLayer(2);

	quit=new QuitText(zero);
	quit->setText("Exit");
	quit->setPos(362,568);
	quit->setSize(300,32);
	quit->setGame(g);
	quit->init();
	quit->setLayer(2);

	ret=new ReturnText(zero);
	ret->setText("Return");
	ret->setPos(362,568);
	ret->setSize(300,32);
	ret->setMenu(this);
	ret->init();
	ret->setLayer(2);

	line1=new TextActor("menuimg/joinpd.ttf",30);
	line1->setText("Under GPL License");
	line1->setPos(362,400);
	line1->setSize(300,32);
	line1->init();
	line1->setLayer(2);

	line2=new TextActor("menuimg/joinpd.ttf",30);
	line2->setText("Programming: Alejandro Castano");
	line2->setPos(362,442);
	line2->setSize(300,32);
	line2->init();
	line2->setLayer(2);

	line3=new TextActor("menuimg/joinpd.ttf",30);
	line3->setText("Graphic: Manuel Albarran");
	line3->setPos(362,484);
	line3->setSize(300,32);
	line3->init();
	line3->setLayer(2);

	line4=new TextActor("menuimg/joinpd.ttf",30);
	line4->setText("Version: 0.43");
	line4->setPos(362,526);
	line4->setSize(300,32);
	line4->init();
	line4->setLayer(2);

	r=new Rect();
	r->init();
	r->setLayer(1);
	g->actormanager->activate(r);

	mainMenu();
}

void MenuChapping::mainMenu()
{
	actual=MAIN;

	g->actormanager->activate(logo);

	g->actormanager->activate(start);
	list->add(start);
	list->addMouse(start);

	g->actormanager->activate(full);
	list->add(full);

	g->actormanager->activate(rightfull);
	list->addMouse(rightfull);
	
	g->actormanager->activate(leftfull);
	list->addMouse(leftfull);

	g->actormanager->activate(choose);
	list->add(choose);

	g->actormanager->activate(rightstadium);
	list->addMouse(rightstadium);

	g->actormanager->activate(leftstadium);
	list->addMouse(leftstadium);

	g->actormanager->activate(about);
	list->add(about);
	list->addMouse(about);

	g->actormanager->activate(quit);
	list->add(quit);
	list->addMouse(quit);

	g->actormanager->activate(r);
}

void MenuChapping::menu(menu_t m)
{
	//Quitamos lo que haya ahora
	list->clear();
	list->clearMouse();
	g->actormanager->desactivateAll();

	actual=m;

	if(m==MAIN)
		mainMenu();
	
	else if(m==ABOUT)
	{
		g->actormanager->activate(logo);

		list->add(ret);
		list->addMouse(ret);
		g->actormanager->activate(ret);
		
		g->actormanager->activate(line1);
		g->actormanager->activate(line2);
		g->actormanager->activate(line3);
		g->actormanager->activate(line4);
		g->actormanager->activate(r);
	}
}

void MenuChapping::unload()
{
	choose->goStadium();

	g->actormanager->erase(logo);
	g->actormanager->erase(start);
	g->actormanager->erase(full);
	g->actormanager->erase(rightfull);
	g->actormanager->erase(leftfull);
	g->actormanager->erase(choose);
	g->actormanager->erase(rightstadium);
	g->actormanager->erase(leftstadium);
	g->actormanager->erase(about);
	g->actormanager->erase(quit);
	g->actormanager->erase(ret);

	g->actormanager->erase(line1);
	g->actormanager->erase(line2);
	g->actormanager->erase(line3);
	g->actormanager->erase(line4);
	g->actormanager->erase(r);
}
