#ifndef MENUCHAPPING_H
#define MENUCHAPPING_H

#include "menu.h"
#include "starttext.h"
#include "quittext.h"
#include "abouttext.h"
#include "arrowmenu.h"
#include "rect.h"
#include "choosestadium.h"
#include "fullscreen.h"
#include "returntext.h"
#include "logo.h"

class MenuChapping : public Menu
{
	public:
		MenuChapping(Game *ag):Menu(ag){}
		~MenuChapping(){}

		typedef enum
		{
			MAIN,
			ABOUT
		}menu_t;

		void load();
		void unload();
		void mainMenu();
		void menu(menu_t);

	private:
		Logo *logo;
		StartText *start;
		Fullscreen *full;
		ArrowMenu* rightfull,*leftfull;
		ChooseStadium *choose;
		ArrowMenu *rightstadium,*leftstadium;
		AboutText *about;
		QuitText *quit;
		ReturnText *ret;

		TextActor *line1;
		TextActor *line2;
		TextActor *line3;
		TextActor *line4;
		Rect* r;
};

#endif
