#include "messenger.h"
#include "actormanager.h"
#include "popup.h"

Messenger::Messenger(Game *ag):g(ag)
{
}

Messenger::~Messenger()
{
}

void Messenger::init()
{
	pass_men=new Message("passmen.png");
	goal_men=new Message("goalmen.png");
	yellow_men=new Message("yellowmen.png");
	red_men=new Message("redmen.png");
	time_men=new Message("timemen.png");
	golden_men=new Message("goldenmen.png");
	win_men=new Message("winmen.png");
	pass_men->init();
	goal_men->init();
	yellow_men->init();
	red_men->init();
	time_men->init();
	golden_men->init();
	win_men->init();

	goal_men->setVelFade(5);
}

void Messenger::send(message_t m)
{
	switch(m)
	{
		case PASS:
			g->actormanager->activate(pass_men);
			break;
		case GOAL:
			g->actormanager->activate(goal_men);
			break;
		case YELLOW:
			g->actormanager->activate(yellow_men);
			break;
		case RED:
			g->actormanager->activate(red_men);
			break;
		case TIME:
			g->actormanager->activate(time_men);
			break;
		case GOLDEN:
			g->actormanager->activate(golden_men);
			break;
		case WIN:
			g->actormanager->activate(win_men);
			break;
	}
}

void Messenger::shutdown()
{
	g->actormanager->erase(pass_men);
	g->actormanager->erase(goal_men);
	g->actormanager->erase(yellow_men);
	g->actormanager->erase(red_men);
	g->actormanager->erase(time_men);
	g->actormanager->erase(golden_men);
	g->actormanager->erase(win_men);
}
