#include <SDL.h>
#include <SDL_image.h>

#include <string>
#include <iostream>

using namespace std;

#include "scoreboard.h"
#include "rendermanager.h"
#include "collision.h"

void ScoreBoard::init()
{
	Image::init();

	width=(int)(img->w/10);
	num=s->getNum();
	rect.w=width*2+SEPARATION;
	rect.h=img->h;
}

void ScoreBoard::update()
{
	Image::update();
	if(num!=s->getNum())
	{
		g->rendermanager->addToDraw(rect);
		num=s->getNum();
	}
}

void ScoreBoard::draw()
{
	//Los rectangulos uno para el destino en la pantalla y otro
	//para coger el numero dentro de la grilla
	SDL_Rect dst=owner->getRect();
	SDL_Rect src;

	if(s->getNum()>99)
		return;
	//Rellenamos num para las decenas
	int dec=(int)(s->getNum()/10);
	src.x=dec*width;
	src.y=0;
	src.w=width;
	src.h=img->h;

	//Pegamos la imagen
	SDL_BlitSurface(img,&src,SDL_GetVideoSurface(),&dst);

	//Ponemos la unidades a la derecha
	dst.x+=width+SEPARATION;

	//Rellenamos num para las unidades
	src.x=(s->getNum()-(dec*10))*width;

	//Pegamos la imagen
	SDL_BlitSurface(img,&src,SDL_GetVideoSurface(),&dst);
}

void ScoreBoard::draw(SDL_Rect &r)
{
	//Los rectangulos uno para el destino en la pantalla y otro
	//para coger el numero dentro de la grilla
	SDL_Rect dst;
	SDL_Rect src;
	SDL_Rect copiarect=rect;

	if(s->getNum()>99)
		return;

	copiarect.w=width;

	//Rellenamos num para las decenas
	int dec=(int)(s->getNum()/10);

	//Comprobamos si tenemos que pintar el primer digito
	if(isCollision(copiarect,r)!=NO_COLLISION)
	{
		dst=getRectCollision(copiarect,r);
		src.w=dst.w;
		src.h=dst.h;
		
		//Si el actor esta a la derecha del rect
		if(r.x<=copiarect.x)
		{
			src.x=0;
		}
		//Si el actor esta a la izquierda del rect
		else
		{
			src.x=r.x-copiarect.x;
		}

		//Si el actor esta por debajo del rectangulo
		if(r.y<=copiarect.y)
		{
			src.y=0;
		}
		//Si el actor esta por encima del rectangulo
		else
		{
			src.y=r.y-copiarect.y;
		}

		src.x=src.x+dec*width;

		//Pegamos la imagen
		SDL_BlitSurface(img,&src,SDL_GetVideoSurface(),&dst);
	}

	copiarect.x=rect.x+width+SEPARATION;

	//Vemos si tenemos que pintar las unidades
	if(isCollision(copiarect,r)!=NO_COLLISION)
	{
		dst=getRectCollision(copiarect,r);
		src.w=dst.w;
		src.h=dst.h;
		
		//Si el actor esta a la derecha del rect
		if(r.x<=copiarect.x)
		{
			src.x=0;
		}
		//Si el actor esta a la izquierda del rect
		else
		{
			//Si el actor esta fuera de la pantalla
			src.x=r.x-copiarect.x;
		}

		//Si el actor esta por debajo del rectangulo
		if(r.y<=copiarect.y)
		{
			src.y=0;
		}
		//Si el actor esta por encima del rectangulo
		else
		{
			src.y=r.y-copiarect.y;
		}
		//Rellenamos num para las unidades
		src.x=src.x+(s->getNum()-(dec*10))*width;

		//Pegamos la imagen
		SDL_BlitSurface(img,&src,SDL_GetVideoSurface(),&dst);
	}
}
