#ifndef STADIUM_H
#define STADIUM_H

#define MAX_TURN 3

#include <string>

#include "actor.h"
#include "goal.h"
#include "ball.h"
#include "game.h"
#include "team.h"
#include "line.h"
#include "timeboard.h"
#include "select.h"
#include "soccergame.h"
#include "collision.h"
#include "activecap.h"
#include "theme.h"
#include "pass.h"
#include "messenger.h"

//Clase que se encarga del campo
class Stadium
{
	public:
		Stadium(Game* ag);
		virtual ~Stadium();

		void init();
		bool update();
		void shutdown();

		void getCollision(Collision &c);

	private:

		void changeTeam(){s->changeTeam();}
		void changeTeam(SG::team_t t){s->changeTeam(t);}
		void startTurn();

		bool isMoving(){return Cap::anyMoving()||ball->isMoving();}

		Cap* isAPass();

		typedef enum
		{
			WAITING,
			MOVING,
			GOAL,
			FAULT,
			BALL
		}state_t;

		state_t state;

		Game *g;
		Goal *g_left,*g_right;
		Ball *ball;

		Theme *theme;
		//Timers
		TimeBoard* time;
		TimeBoard* seconds;
		TimeBoard* minutes;

		//Scoresboards
		Score* s_left;
		Score* s_right;

		//Para los equipos
		Team teams[2];
		int turn;

		//Selector de equipos
		Select *s;

		//Pase
		Pass *pass;

		//Pasador
		Cap *cap_pass;
		Cap *cap_fault;

		Messenger *messenger;

		bool goldengoal;
		bool finish;
};

#endif
