#ifndef TEAM_H
#define TEAM_H

#include <vector>
#include "cap.h"
#include "game.h"
#include "teammanager.h"
#include "theme.h"

//Clase equipo que tiene un teammanager para manejar los movimientos
class Team
{
	public:
		Team();
		~Team();

		void init(Game::team_t t,const Theme *t);
		void update();
		void shutdown();

		void collocateCaps();
		static void setGame(Game *ag){g=ag;}
		//Un turno nuevo para el equipo
		void throwCap(){m->throws();}
		//Comprueba si ha acabado el turno
		bool isOver();
		//Para el turno
		void stop(){m->stop();}
		//Un pase es un tiro mas
		void oneMore(Cap *c){m->oneMore(c);}

		//Obtener una chapa y borrarla
		Cap* getCap(int i);
		void delCap(Cap *c);

		//Obtener el numero de chapas que le 
		//quedan al equipo por expulsion
		int getNumCaps()const{return num_caps;}

	private:
		//Vector de chapas
		vector<Cap*> caps;

		//Numero de chapas en el equipo
		int num_caps;
		static Game *g;
		//Clase de equipo: derecha o izquierda
		TeamManager *m;
		Game::team_t team;
};

#endif
