#ifndef TEAMMANAGER_H
#define TEAMMANAGER_H

#include "game.h"
#include "vector.h"
#include "cap.h"

//Clase abstracta pura para manejar equipos
//Se crean clases a partir de esta para manejar al equipo un humano,
//a traves de la red o con inteligencia artificial
class TeamManager
{
	public:
		TeamManager(){}
		virtual ~TeamManager(){}

		static void setGame(Game *ag){g=ag;}
		virtual void init(Game::team_t t)=0;
		virtual void update()=0;
		virtual void shutdown()=0;
		virtual void stop()=0;
		virtual void throws()=0;
		virtual bool isOver()=0;
		virtual void oneMore(Cap* c)=0;

		int getCap(){return capID;}
		Vector getVel(){return vel;}
		Vector getAccel(){return accel;}

	protected:
		static Game *g;
		Game::team_t team;
		int capID;
		Vector vel;
		Vector accel;
};

#endif
