#include "theme.h"
#include <iostream>
#include <fstream>

using namespace std;

Theme::Theme(string filename)
{
	//abro el archivo donde guardo los datos
	ifstream file(filename.c_str(), ifstream::in);
	
	//si falla al abrir, aviso y salgo
	if(!file)
	{
		cout << "Fallo al abrir el archivo: " << filename <<endl;
		exit(-1);
	}
	
	while(getline(file,line,'\n'))
	{
		//busco el caracter ':' dentro de la linea y me quedo con su posicion
		string::size_type pos = line.find(":",0);
		if(pos==0)
			continue;
		
		//saco el tamano de la linea
		string::size_type size = line.size();
		
		//almaceno en una nueva string con el nombre de la variable
		subline = line.substr(0, pos);
		
		//almaceno en una nueva string el valor de la variable
		value = line.substr((pos+2),(size-pos));
		
		if(subline=="theme_name")
			theme_name = value;
		else if(subline=="theme_description")
			theme_description = atoi(value.c_str());
		else if(subline=="author_name")
			author_name=value;
		else if(subline=="author_nick")
			author_nick=value;
		else if(subline=="background")
			background=value;
		else if(subline == "movements")
			movements=atoi(value.c_str());
		else if(subline == "caps")
			caps=atoi(value.c_str());
		else if(subline=="cap_left_1_x")
			cap_left_1_x=atof(value.c_str());
		else if(subline=="cap_left_1_y")
			cap_left_1_y=atof(value.c_str());
		else if(subline=="cap_left_2_x")
			cap_left_2_x=atof(value.c_str());
		else if(subline=="cap_left_2_y")
			cap_left_2_y=atof(value.c_str());
		else if(subline=="cap_left_3_x")
			cap_left_3_x=atof(value.c_str());
		else if(subline=="cap_left_3_y")
			cap_left_3_y=atof(value.c_str());
		else if(subline=="cap_left_4_x")
			cap_left_4_x=atof(value.c_str());
		else if(subline=="cap_left_4_y")
			cap_left_4_y=atof(value.c_str());
		else if(subline=="cap_left_5_x")
			cap_left_5_x=atof(value.c_str());
		else if(subline=="cap_left_5_y")
			cap_left_5_y=atof(value.c_str());
		else if(subline=="cap_left_6_x")
			cap_left_6_x=atof(value.c_str());
		else if(subline=="cap_left_6_y")
			cap_left_6_y=atof(value.c_str());
		else if(subline=="cap_left_7_x")
			cap_left_7_x=atof(value.c_str());
		else if(subline=="cap_left_7_y")
			cap_left_7_y=atof(value.c_str());
		else if(subline=="cap_left_8_x")
			cap_left_8_x=atof(value.c_str());
		else if(subline=="cap_left_8_y")
			cap_left_8_y=atof(value.c_str());
		else if(subline=="cap_left_9_x")
			cap_left_9_x=atof(value.c_str());
		else if(subline=="cap_left_9_y")
			cap_left_9_y=atof(value.c_str());
		else if(subline=="cap_left_10_x")
			cap_left_10_x=atof(value.c_str());
		else if(subline=="cap_left_10_y")
			cap_left_10_y=atof(value.c_str());
		else if(subline=="cap_right_1_x")
			cap_right_1_x=atof(value.c_str());
		else if(subline=="cap_right_1_y")
			cap_right_1_y=atof(value.c_str());
		else if(subline=="cap_right_2_x")
			cap_right_2_x=atof(value.c_str());
		else if(subline=="cap_right_2_y")
			cap_right_2_y=atof(value.c_str());
		else if(subline=="cap_right_3_x")
			cap_right_3_x=atof(value.c_str());
		else if(subline=="cap_right_3_y")
			cap_right_3_y=atof(value.c_str());
		else if(subline=="cap_right_4_x")
			cap_right_4_x=atof(value.c_str());
		else if(subline=="cap_right_4_y")
			cap_right_4_y=atof(value.c_str());
		else if(subline=="cap_right_5_x")
			cap_right_5_x=atof(value.c_str());
		else if(subline=="cap_right_5_y")
			cap_right_5_y=atof(value.c_str());
		else if(subline=="cap_right_6_x")
			cap_right_6_x=atof(value.c_str());
		else if(subline=="cap_right_6_y")
			cap_right_6_y=atof(value.c_str());
		else if(subline=="cap_right_7_x")
			cap_right_7_x=atof(value.c_str());
		else if(subline=="cap_right_7_y")
			cap_right_7_y=atof(value.c_str());
		else if(subline=="cap_right_8_x")
			cap_right_8_x=atof(value.c_str());
		else if(subline=="cap_right_8_y")
			cap_right_8_y=atof(value.c_str());
		else if(subline=="cap_right_9_x")
			cap_right_9_x=atof(value.c_str());
		else if(subline=="cap_right_9_y")
			cap_right_9_y=atof(value.c_str());
		else if(subline=="cap_right_10_x")
			cap_right_10_x=atof(value.c_str());
		else if(subline=="cap_right_10_y")
			cap_right_10_y=atof(value.c_str());
		else if(subline=="cap_mass")
			cap_mass=atof(value.c_str());
		else if(subline=="ball_mass")
			ball_mass=atof(value.c_str());
		else if(subline=="activecap_frames")
			activecap_frames=atoi(value.c_str());
		else if(subline=="graze")
			graze=atof(value.c_str());
		else if(subline=="stadium_x")
			stadium_x=atoi(value.c_str());
		else if(subline=="stadium_y")
			stadium_y=atoi(value.c_str());
		else if(subline=="stadium_h")
			stadium_h=atoi(value.c_str());
		else if(subline=="stadium_w")
			stadium_w=atoi(value.c_str());
		else if(subline=="goal_left_x")
			goal_left_x=atoi(value.c_str());
		else if(subline=="goal_left_y")
			goal_left_y=atoi(value.c_str());
		else if(subline=="goal_right_x")
			goal_right_x=atoi(value.c_str());
		else if(subline=="goal_right_y")
			goal_right_y=atoi(value.c_str());
		else if(subline=="goal_w")
			goal_w=atoi(value.c_str());
		else if(subline=="goal_h")
			goal_h=atoi(value.c_str());
		else if(subline=="poster")
			poster=atoi(value.c_str());
		else if(subline=="scoreboard_1_cap_x")
			scoreboard_1_cap_x=atoi(value.c_str());
		else if(subline=="scoreboard_1_cap_y")
			scoreboard_1_cap_y=atoi(value.c_str());
		else if(subline=="scoreboard_1_name_x")
			scoreboard_1_name_x=atoi(value.c_str());
		else if(subline=="scoreboard_1_name_y")
			scoreboard_1_name_y=atoi(value.c_str());
		else if(subline=="scoreboard_1_goals_x")
			scoreboard_1_goals_x=atoi(value.c_str());
		else if(subline=="scoreboard_1_goals_y")
			scoreboard_1_goals_y=atoi(value.c_str());
		else if(subline=="scoreboard_2_cap_x")
			scoreboard_2_cap_x=atoi(value.c_str());
		else if(subline=="scoreboard_2_cap_y")
			scoreboard_2_cap_y=atoi(value.c_str());
		else if(subline=="scoreboard_2_name_x")
			scoreboard_2_name_x=atoi(value.c_str());
		else if(subline=="scoreboard_2_name_y")
			scoreboard_2_name_y=atoi(value.c_str());
		else if(subline=="scoreboard_2_goals_x")
			scoreboard_2_goals_x=atoi(value.c_str());
		else if(subline=="scoreboard_2_goals_y")
			scoreboard_2_goals_y=atoi(value.c_str());
		else if(subline=="time")
			time=atoi(value.c_str());
		else if(subline=="time_team")
			time_team=atoi(value.c_str());
		else if(subline=="time_team_x")
			time_team_x=atoi(value.c_str());
		else if(subline=="time_team_y")
			time_team_y=atoi(value.c_str());
		else if(subline=="time_min_x")
			time_min_x=atoi(value.c_str());
		else if(subline=="time_min_y")
			time_min_y=atoi(value.c_str());
		else if(subline=="time_sec_x")
			time_sec_x=atoi(value.c_str());
		else if(subline=="time_sec_y")
			time_sec_y=atoi(value.c_str());
		else if(subline=="select_left_x")
			select_left_x=atoi(value.c_str());
		else if(subline=="select_left_y")
			select_left_y=atoi(value.c_str());
		else if(subline=="select_right_x")
			select_right_x=atoi(value.c_str());
		else if(subline=="select_right_y")
			select_right_y=atoi(value.c_str());
		else
		{
			cerr<<"Error al leer una variable no valida de pista."<<endl;
			cout<<subline<<endl;
//			exit(-1);
		}
	}
}
