#ifndef ACTORGRAPHIC_H
#define ACTORGRAPHIC_H

#include <SDL.h>

#include "game.h"
#include "vector.h"

class Actor;

//Clase abstracta con la caracteristica de poder ser dibujados en
//pantalla. A partir de esta clase se crean clases como Imagen, animacion
//o pixel
class ActorGraphic
{
	public:
		ActorGraphic(Actor *a):owner(a){center=Vector(zero);}
		virtual ~ActorGraphic(){}

		virtual void init(){}
		virtual void activate(){}
		virtual void update(){}
		virtual void desactivate(){}

		void static setGame(Game *game){g=game;}

		virtual void draw(){}
		virtual void draw(SDL_Rect &r){draw();}
			
		virtual unsigned get_w()const{return 0;} 
		virtual unsigned get_h()const{return 0;}

		SDL_Rect getRect()const{return rect;}
		/*
		virtual int get_x();
		virtual int get_y();
		*/

	protected:
		Actor *owner;
		static Game *g;
		SDL_Rect rect;
		Vector center;
};

#endif
