#ifndef ACTORMANAGER_H
#define ACTORMANAGER_H

#include <algorithm>
#include <list>
#include "actor.h"
#include "actorgraphic.h"

using namespace std;

class Game;

class ActorManager
{
	public:
		ActorManager(Game *ag);
		~ActorManager();

		void init(){Actor::setGame(g);ActorGraphic::setGame(g);}
		void update();
		void shutdown();

		void clear(){shutdown();}
		void desactivateAll();
		//Anadir y eliminar actores
		void activate(Actor *a){to_activate.push_back(a);}
		void desactivate(Actor *a){to_desactivate.push_back(a);}
		void erase(Actor *a){to_erase.push_back(a);}

		//Pone el puntero al principio de la lista
		void rewind(){actors_iter=actors.begin();}
		//devuelve el siguiente actor de la lista
		//sirve para recorrer la lista por orden
		Actor* next();
		//devuelve el actor apuntado por la lista
		Actor* current();
		//Cuantos actores hay
		int numActors(){return actors.size();}

		//posiciona el iterador donde queremos
		bool setPosition(Actor *a);

		list<Actor*>::iterator get_begin_iterator(){return actors.begin();}
		list<Actor*>::iterator get_end_iterator(){return actors.end();}

	protected:
		Game *g;

		//lista de actores
		list<Actor*> actors;
		list<Actor*>::iterator actors_iter;

		//lista de actores para desactivar actores
		list<Actor*> to_desactivate;
		//lista de actores para activar actores
		list<Actor*> to_activate;
		//lista de actores para eliminar actores
		list<Actor*> to_erase;

		//Activar actores en espera
		void activateQueue();
		//Desactivar actores en espera
		void desactivateQueue();
		//Eliminar actores en espera
		void eraseQueue();
};

#endif
