#ifndef COLLISION_H
#define COLLISION_H

#include <SDL.h>

#include "circle.h"
#include "box.h"
#include "boxactor.h"
#include "circularactor.h"

typedef enum
{
	ROUND,
	WALL,
	CORNER
}collision_t;

struct Collision
{
	float t;
	Actor *a;
	Actor *b;
	collision_t type;
};

typedef enum
{
	NO_COLLISION=2,
	COLLISION,
	IN
}static_t;

static_t isCollision(const Actor *a,const Actor* b);
static_t isCollision(const Actor *a,const SDL_Rect &r);
static_t isCollision(const SDL_Rect &a,const SDL_Rect &r);

static_t position(const Circle *bigger,const Circle *smaller);
static_t position(const Box *bigger,const Box *smaller);
static_t position(SDL_Rect const &bigger,SDL_Rect const &smaller);
static_t position(const Circle *bigger,const Box *smaller);
static_t position(const Box *bigger,const Circle *smaller);

static_t position(const Vector *p1,const Vector *r1,const Vector *p2,const Vector *r2);

static_t isCollision(const CircularActor *bigger,const CircularActor *smaller);
static_t isCollision(const BoxActor *bigger,const BoxActor *smaller);
static_t isCollision(const CircularActor *bigger,const BoxActor *smaller);
static_t isCollision(const BoxActor *bigger,const CircularActor *smaller);

static_t isCollision(const Vector &v,const Circle *c);
static_t isCollision(const Vector &v,const Box *b);
static_t isCollision(const Vector &v,const CircularActor *c);
static_t isCollision(const Vector &v,const BoxActor *b);
static_t isCollision(const Vector &v,const BoxActor *b);
static_t isCollision(const Vector &v,const Actor *a);
static_t isCollision(const Vector p,const Vector r,const CircularActor *c);

SDL_Rect getRectCollision(const SDL_Rect &a,const SDL_Rect &b);
SDL_Rect getRectCollision(const Box *a,const Box *b);
#endif
