#ifndef COLLISIONMANAGER_H
#define COLLISIONMANAGER_H

#include "game.h"
#include "circularactor.h"
#include "boxactor.h"

#include "collision.h"

//Clase encargada de las colisiones del juego
class CollisionManager
{
	public:
		CollisionManager(Game *ag):g(ag){}
		virtual ~CollisionManager(){}

		virtual void init();
		virtual void update();
		virtual void shutdown();

		virtual void timeOfCollision(const float t_max);
		
	protected:
		virtual void move(const float t);
		virtual void move(Collision &c);

		Collision collision(Collision &c);
		Collision collision(const CircularActor* move_cir,
				const CircularActor* stop_cir);
		Collision collision(const CircularActor* cir,const BoxActor *line);
		Collision collision(const CircularActor* cir,const Vector &point);
		Game *g;
};
#endif
