#ifndef CONTROL_H
#define CONTROL_H

#include <list>
#include <string>
#include "peripheral.h"
#include "controllable.h"

using namespace std;

//Clase que guarda todos las acciones de un mismo personaje
//O sea que si hubiera dos personajes distinto habria
//dos controles distintos
class Control
{
	public:
		//Definicion de association, tipo de dato que relaciona
		//un evento de un periferico cualquiera con una accion 
		typedef struct
		{
			Controllable::action_t act;
			string name;
			Peripheral *peri;
			Peripheral::component_t comp;
			Peripheral::event_t event;
		}association_t;

		void update();

		//Crea una associacion con un nombre y una accion
		void addActionName(Controllable::action_t act, string str);
		//A la association creada anteriormente le definimos el resto de 
		//elementos
		void setActionPeripheral(Controllable::action_t act,
				Peripheral* peri, Peripheral::component_t comp,
				Peripheral::event_t e);
		//Anade una associacion directamente
		void addAssociation(association_t assoc){
			associations.push_back(assoc);}
		//Todo control tiene un priopietario
		void setOwner(Controllable* co){owner=co;}
		//Devuelve el nombre de una accion
		string getNameAction(Controllable::action_t);
		void reset();

	protected:
		Controllable* owner;
		list<association_t> associations;
		list<association_t>::iterator associations_iter;
};

#endif
