#ifndef __CONTROLMANAGER_H
#define __CONTROLMANAGER_H

#include <SDL.h>
#include <vector>

#include "game.h"
#include "control.h"
#include "keyboard.h"
#include "mouse.h"


//Tiene la lista de todos los controles que los actualiza, crea y elimina
//Tiene la lista de todos los perifericos que los actualiza, crea y elimina
class ControlManager
{
	public:
		ControlManager(Game *g);
		~ControlManager();

		void update();
		void init();
		void shutdown();

		//Anadir controles
		int add(Control *c);
		int del(Control *c);

		Keyboard* kbd;
		Mouse* mouse;

	protected:

		list<Control*> controls;
		list<Control*>::iterator controls_iter;

		Game *game;

		void get_events();
};

#endif
