#include "fontmanager.h"

void FontManager::init()
{
	if(TTF_Init()!=0)
	{
		fprintf(stderr,"No se puede iniciar SDL_TTF: %s\n",SDL_GetError());
		exit(-1);
	}
}

void FontManager::update()
{
}

void FontManager::shutdown()
{
	for(unsigned i=0;i<fonts.size();i++)
	{
		TTF_CloseFont(fonts[i]->f);
		delete (fonts[i]);
	}
	TTF_Quit();
}

FontManager::font_id FontManager::loadTTF(string name,int s)
{
	//Si ya hemos abierto la fuente le pasamos el numero id correspondiente
	for(unsigned i=0;i<fonts.size();i++)
	{
		if(fonts[i]->name==name && fonts[i]->size==s)
			return i;
	}
	font_t *aux=new font_t;
	aux->name=name;
	aux->size=s;
	aux->f=TTF_OpenFont(name.c_str(),s);
	fonts.push_back(aux);
	return fonts.size()-1;
}

SDL_Surface* FontManager::getTextSolid(string text,font_id font)
{
	if(font>=fonts.size())
		return NULL;
	SDL_Color c={255,255,255,0};
	return getTextSolid(text,font,c);
}

SDL_Surface* FontManager::getTextSolid(string text,font_id font,SDL_Color color)
{
	if(font>=fonts.size())
		return NULL;
	return TTF_RenderText_Solid(fonts[font]->f,text.c_str(),color);
}

SDL_Surface* FontManager::getTextShaded(string text,font_id font)
{
	if(font>=fonts.size())
		return NULL;
	SDL_Color c={255,255,255,0};
	SDL_Color b={0,0,0,255};
	return getTextShaded(text,font,c,b);
}

SDL_Surface* FontManager::getTextShaded(string text,font_id font,SDL_Color color)
{
	if(font>=fonts.size())
		return NULL;
	SDL_Color b={0,0,0,255};
	return getTextShaded(text,font,color,b);
}

SDL_Surface* FontManager::getTextShaded(string text,font_id font,SDL_Color color,SDL_Color back)
{
	if(font>=fonts.size())
		return NULL;
	return TTF_RenderText_Shaded(fonts[font]->f,text.c_str(),color,back);
}

SDL_Surface* FontManager::getTextBlended(string text,font_id font)
{
	if(font>=fonts.size())
		return NULL;
	SDL_Color c={255,255,255,0};
	return getTextBlended(text,font,c);
}

SDL_Surface* FontManager::getTextBlended(string text,font_id font,SDL_Color color)
{
	if(font>=fonts.size())
		return NULL;
	return TTF_RenderText_Blended(fonts[font]->f,text.c_str(),color);
}
