#ifndef FONTMANAGER_H
#define FONTMANAGER_H

#include <SDL.h>
#include <SDL_ttf.h>
#include <vector>
#include <string>

#include "game.h"

using namespace std;

class FontManager
{
	public:
		FontManager(Game *ag):g(ag){}
		~FontManager(){}

		void init();
		void update();
		void shutdown();

		typedef unsigned font_id;

		typedef struct
		{
			TTF_Font* f;
			int size;
			string name;
		}font_t;

		font_id loadTTF(string name,int tam);
		SDL_Surface* getTextSolid(string text,font_id font);
		SDL_Surface* getTextSolid(string text,font_id font,SDL_Color color);
		SDL_Surface* getTextShaded(string text,font_id font);
		SDL_Surface* getTextShaded(string text,font_id font,SDL_Color color);
		SDL_Surface* getTextShaded(string text,font_id font,SDL_Color color,
				SDL_Color background);
		SDL_Surface* getTextBlended(string text,font_id font);
		SDL_Surface* getTextBlended(string text,font_id font,SDL_Color color);

		SDL_Surface* getText(string text,font_id font)
			{return getTextSolid(text,font);}
		SDL_Surface* getText(string text,font_id font,SDL_Color color)
			{return getTextSolid(text,font,color);}

	private:
		vector<font_t*> fonts;
		Game *g;
};

#endif
