#ifndef __GAME_H
#define __GAME_H

#include <SDL.h>
#include <string>

using namespace std;

class ActorManager;
class RenderManager;
class TimeManager;
class ControlManager;
class CollisionManager;
class FontManager;
class Collision;

//Clase principal donde se mantiene todos los manager
//Se modifica la main que es donde empieza el juego
class Game
{
	public:
		Game();
		virtual ~Game();

		ActorManager *actormanager;
		RenderManager *rendermanager;
		TimeManager *timemanager;
		ControlManager *controlmanager;
		CollisionManager *collisionmanager;
		FontManager *fontmanager;

		virtual int init(int w,int h,int col);
		virtual void main();
		void setName(const string name);
		string getName()const{return name;}
		void setIcon(const string icon);
		string getIcon()const{return icon;}

		void setEnd(int v=0){end=1;returnvalue=v;}
		typedef int team_t;

		virtual void getCollision(Collision &c){}

	protected:
		bool end;
		int returnvalue;
		string name;
		string icon;
		virtual void load(){}
		virtual void logicgame(){}
		virtual void unload(){}

	private:
		void start();
		void shutdown(string message="Gracias por jugar");
		void update();
		virtual void create_actormanager();
		virtual void create_rendermanager(int w,int h,int col);
		virtual void create_timemanager();
		virtual void create_controlmanager();
		virtual void create_collisionmanager();
		virtual void create_fontmanager();
};

#endif
