#include <SDL.h>
#include <SDL_rotozoom.h>

#include <string>

using namespace std;

#include "image.h"
#include "utils.h"
#include "rendermanager.h"
#include "actor.h"
#include "collision.h"

void Image::init()
{
	img=LoadImgAlpha(name);
	center=owner->getCenter();
}

void Image::activate()
{
	rect=owner->getRect();
	center=owner->getCenter();
	g->rendermanager->addToDraw(rect);
}

void Image::update()
{
	if(center!=owner->getCenter())
	{
		//Poner el fondo donde estaba antes
		g->rendermanager->addToDraw(rect);

		center=owner->getCenter();
		rect=owner->getRect();

		//Poner el fondo donde va a estar ahora
		g->rendermanager->addToDraw(rect);
	}
}

void Image::desactivate()
{
	g->rendermanager->addToDraw(rect);
}

void Image::flip()
{
	SDL_Surface *aux=img;
	img=rotozoomSurface(img,180,1,SMOOTHING_ON);
	SDL_FreeSurface(aux);
	g->rendermanager->addToDraw(rect);
	change=true;
}

void Image::draw()
{
	SDL_Rect r=rect;
	SDL_BlitSurface(img,NULL,SDL_GetVideoSurface(),&r);
}

void Image::draw(SDL_Rect &r)
{
	SDL_Rect src;
	SDL_Rect dst;

	dst=getRectCollision(rect,r);
	src.w=dst.w;
	src.h=dst.h;

	//Rellenamos los rectangulos src y dst
	//para pintar solo lo que se ha modificado
	//Si el actor esta a la derecha del rect
	if(r.x<=rect.x)
	{
		src.x=0;
	}
	//Si el actor esta a la izquierda del rect
	else
	{
		//Si el actor esta fuera de la pantalla
		src.x=r.x-rect.x;
	}

	//Si el actor esta por debajo del rectangulo
	if(r.y<=rect.y)
	{
		src.y=0;
	}
	//Si el actor esta por encima del rectangulo
	else
	{
		src.y=r.y-rect.y;
	}

	SDL_BlitSurface(img,&src,SDL_GetVideoSurface(),&dst);
}
