#include <SDL.h>

#include "keyboard.h"
#include "peripheral.h"

Keyboard::Keyboard()
{
}

Keyboard::~Keyboard()
{
}

void Keyboard::init()
{
	reset();
}

void Keyboard::update()
{
	for(int i=0;i<SDLK_LAST;i++)
		key_state[i]=keys[i];
}

void Keyboard::shutdown()
{
}

Peripheral::event_t Keyboard::get_event(component_t comp)
{
	if((comp>=0)&&(comp<SDLK_LAST))
		if((keys[comp]))
			return ON_PRESS;

	return ON_RELEASE;
}

Peripheral::state_t Keyboard::get_state(component_t comp)
{
	if((comp>=0)&&(comp<SDLK_LAST))
		if((keys[comp]))
			return true;

	return false;
}

void Keyboard::reset()
{
	for(int i=0;i<=SDLK_LAST;i++)
	{
		keys[i]=0;
		key_state[i]=0;
	}
}

string Keyboard::get_component_name(component_t comp)
{
	//return SDL_GetKeyName(comp);
	return "nada";
}
