#ifndef __KEYBOARD_H
#define __KEYBOARD_H

#include <SDL.h>
#include "peripheral.h"

//La definicion de teclado que es un periferico
class Keyboard : public Peripheral
{
	public:
		Keyboard();
		virtual ~Keyboard();

		void init();
		void update();
		void shutdown();

		event_t get_event(component_t comp);
		bool is_change(component_t comp){return keys[comp]!=key_state[comp];}
		state_t get_state(component_t comp);
		void set_component(component_t comp,state_t s){keys[comp]=s;}
		string get_component_name(component_t comp);
		void reset();

	protected:
		bool keys[SDLK_LAST];
		bool key_state[SDLK_LAST];
};

#endif
