#ifndef MENUCONTROLLER_H
#define MENUCONTROLLER_H

#include "controllable.h"
#include "control.h"
#include "game.h"
#include "menulist.h"

class MenuController : public Controllable
{
	public:
		MenuController(Game *ag,MenuList *l):list(l),g(ag),el_onmouse(NULL),
			el_click(NULL){}
		~MenuController(){}

		typedef enum
		{
			UP,
			DOWN,
			LEFT,
			RIGHT,
			ENTER,
			CLICK,
			UNCLICK,
			MOVE_X,
			MOVE_Y,
			QUIT
		}action_t;

		void init();
		void shutdown();

		void setGame(Game *ag){g=ag;}
		void doAction(Controllable::action_t action,int magnitude=0);

	private:
		MenuList *list;
		Control *controller;
		Game *g;

		MenuMouseElement *el_onmouse;
		MenuMouseElement *el_click;
};

#endif
