#include "menulist.h"
#include "actormanager.h"

void MenuList::update()
{
}

void MenuList::shutdown()
{
	/*
	list<MenuElement*>::iterator tmp_iter;
	for(tmp_iter=elements.begin();tmp_iter!=elements.end();tmp_iter++)
		g->actormanager->erase(*tmp_iter);
		*/
}

void MenuList::add(MenuElement *e)
{
	elements.push_back(e);
}

MenuElement* MenuList::next()
{
	MenuElement* tmp;

	//Si es el ultimo devolvemos NULL
	if(actual_el==elements.size() || elements.size()==0)
		return NULL;

	tmp=elements[actual_el];
	actual_el++;
	return tmp;
}

MenuElement* MenuList::current()
{
	//Devuelve el elemento actual sin avanzar
	if(actual_el==elements.size() || elements.size()==0)
		return NULL;
	return elements[actual_el];
}

void MenuList::addMouse(MenuMouseElement *e)
{
	mouse.push_back(e);
}

MenuMouseElement* MenuList::nextMouse()
{
	MenuMouseElement* tmp;

	//Si es el ultimo devolvemos NULL
	if(actual_mouse==mouse.size() || mouse.size()==0)
		return NULL;

	tmp=mouse[actual_mouse];
	actual_mouse++;
	return tmp;
}

MenuMouseElement* MenuList::currentMouse()
{
	//Devuelve el elemento actual sin avanzar
	if(actual_mouse==mouse.size() || mouse.size()==0)
		return NULL;
	return mouse[actual_mouse];
}

void MenuList::goDown()
{
	if(elements.size()==0)
		return;

	if(!selectedIn())
		return;

	elements[selected]->getSignal(MenuElement::UNSELECTED);

	selected++;
	if(selected==(signed)elements.size())
		selected=0;

	elements[selected]->getSignal(MenuElement::SELECTED);
}

void MenuList::goUp()
{
	if(elements.size()==0)
		return;

	if(!selectedIn())
		return;

	elements[selected]->getSignal(MenuElement::UNSELECTED);

	if(selected==0)
		selected=elements.size();
	selected--;

	elements[selected]->getSignal(MenuElement::SELECTED);
}

void MenuList::goLeft()
{
	if(elements.size()==0)
		return;

	if(!selectedIn())
		return;

	elements[selected]->getSignal(MenuElement::PRESS_LEFT);
}

void MenuList::goRight()
{
	if(elements.size()==0)
		return;

	if(!selectedIn())
		return;

	elements[selected]->getSignal(MenuElement::PRESS_RIGHT);
}

void MenuList::pressEnter()
{
	if(elements.size()==0)
		return;

	if(!selectedIn())
		return;

	elements[selected]->getSignal(MenuElement::PRESS_ENTER);
}

bool MenuList::selectedIn()
{
	if(!is_selected)
	{
		is_selected=true;
		selected=0;
		elements[selected]->getSignal(MenuElement::SELECTED);
		return false;
	}
	return true;
}

bool MenuList::selectedOut()
{
	if(is_selected)
	{
		is_selected=false;
		elements[selected]->getSignal(MenuElement::UNSELECTED);
		return false;
	}
	return true;
}
