#ifndef MENULIST_H
#define MENULIST_H

#include "menuelement.h"
#include "menumouseelement.h"
#include "game.h"
#include <list>
#include <vector>

using namespace std;

class MenuList
{
	public:
		MenuList(Game *ag):is_selected(false),selected(0),g(ag){}
		~MenuList(){}

		void init(){}
		void update();
		void shutdown();

		//Pone el iterador al principio de la lista
		void rewind(){actual_el=0;}
		void rewindMouse(){actual_mouse=0;}

		//Recorrer la lista
		MenuElement* next();
		MenuElement* current();

		//Recorrer la lista del raton
		MenuMouseElement* nextMouse();
		MenuMouseElement* currentMouse();

		//Anyadir
		void add(MenuElement *e);
		void addMouse(MenuMouseElement *e);
		
		//Quitar
		void clear(){elements.clear();}
		void clearMouse(){mouse.clear();}

		//Numero de elementos
		int numElements(){return elements.size();}
		int numMouseElements(){return mouse.size();}

		//Mover el seleccionado
		void goDown();
		void goUp();
		void goLeft();
		void goRight();
		//Accion
		void pressEnter();

		//Quitar y poner el selector
		//Devuelve true si ya estaba in u out
		bool selectedOut();
		bool selectedIn();

	protected:
		unsigned actual_el;
		bool is_selected;
		int selected;
		vector<MenuElement*> elements;
		unsigned actual_mouse;
		vector<MenuMouseElement*> mouse;

		Game *g;
};

#endif
