#ifndef MENUMOUSEELEMENT_H
#define MENUMOUSEELEMENT_H

#include "vector.h"

class MenuMouseElement
{
	public:
		MenuMouseElement(zero_t):priority(0){}
		virtual ~MenuMouseElement(){}

		typedef enum
		{
			ON_MOUSEOVER,
			ON_MOUSEOUT,
			CLICKED,
			UNCLICKED,
		}mousesignal_t;

		virtual void getMouseSignal(mousesignal_t s)=0;

		virtual bool isHere(Vector &v)=0;

		int getPriority()const{return priority;}

		static bool elementPrioritySort(const MenuMouseElement* left
				,const MenuMouseElement* right)
				{return left->getPriority()>right->getPriority();}

	protected:
		int priority;
};

#endif
