#ifndef __MOUSE_H
#define __MOUSE_H

#include <SDL.h>
#include "peripheral.h"

#define MOUSEBUTTONS 6

//La clase raton que es un peripherico
class Mouse : public Peripheral
{
	public:
		Mouse();
		virtual ~Mouse();

		void init();
		void update();
		void shutdown();

		typedef enum
		{
			MOUSE_LBUTTON=SDL_BUTTON_LEFT,
			MOUSE_MBUTTON=SDL_BUTTON_MIDDLE,
			MOUSE_RBUTTON=SDL_BUTTON_RIGHT,
			MOUSE_UP=SDL_BUTTON_WHEELUP,
			MOUSE_DOWN=SDL_BUTTON_WHEELDOWN,
			MOUSE_X,
			MOUSE_Y
		}component_t;

		Peripheral::event_t get_event(Peripheral::component_t comp);
		bool is_change(Peripheral::component_t comp);
		Peripheral::state_t get_state(Peripheral::component_t comp);
		void set_component(Peripheral::component_t comp,state_t s);
		string get_component_name(Peripheral::component_t comp);
		void reset();

	protected:
		int x,y;
		int old_x,old_y;
		bool buttons[MOUSEBUTTONS];
		bool old_buttons[MOUSEBUTTONS];
};

#endif
