#ifndef PERIPHERAL_H
#define PERIPHERAL_H

#include <string>

using namespace std;

class Peripheral
{
	public:

		Peripheral(){}
		virtual ~Peripheral(){}
		virtual void init()=0;
		virtual void update()=0;
		virtual void shutdown()=0;

		//Tipos de evento que se pueden dar en un componente de un 
		//periferico
		typedef enum event_t
		{
			NO_EVENT,
			ON_PRESS,
			ON_RELEASE,
			ON_PRESSING,
			ON_RELEASSING
		};

		//El estado de un componente de un periferico
		//Por ejemplo la posicion X del raton
		typedef int state_t;
		//Los distintos componentes que puede tener un periferico
		typedef int component_t;

		//Devuelve si el componente esta activado ON_PRESS
		//o no ON_RELEASE
		virtual event_t get_event(component_t comp)=0;

		//Devuelve si ha cambiado el componente desde la ultima vez
		virtual bool is_change(component_t comp)=0;

		//Devuelve el estado (posicion del raton) del componente
		virtual state_t get_state(component_t comp)=0;

		//Modifica el componente en el periferico virtual
		virtual void set_component(component_t comp,state_t s)=0;

		virtual string get_component_name(component_t comp)=0;
		virtual void reset()=0;
};

#endif
