#include <SDL.h>

#include <string>

using namespace std;

#include "popup.h"
#include "utils.h"
#include "rendermanager.h"
#include "actor.h"
#include "actormanager.h"

#define MINALPHA 2
#define MAXALPHA 255

void PopUp::init()
{
	if(img==NULL)
		img=LoadImg(name);
}

void PopUp::activate()
{
	alpha=5;
	rect=owner->getRect();
	g->rendermanager->addToDraw(rect);
}

void PopUp::update()
{
	//Lo vamos haciendo mas transparente
	alpha+=vel;
	if(alpha>=MAXALPHA)
	{
		vel=-vel;
		alpha=MAXALPHA;
	}
	if(alpha<MINALPHA)
		g->actormanager->desactivate(owner);
	else
	{
		SDL_SetAlpha(img,SDL_SRCALPHA,alpha);
		//Poner el fondo donde estaba antes
		g->rendermanager->addToDraw(rect);

		rect=owner->getRect();

		//Poner el fondo donde va a estar ahora
		g->rendermanager->addToDraw(rect);
	}
}

void PopUp::desactivate()
{
	vel=-vel;
	rect=owner->getRect();
	g->rendermanager->addToDraw(rect);
}

void PopUp::draw()
{
	SDL_BlitSurface(img,NULL,SDL_GetVideoSurface(),&rect);
}
