#include <SDL.h>
#include <SDL_gfxPrimitives.h>

#include "rectangleimage.h"
#include "rendermanager.h"
#include "boxactor.h"
#include "collision.h"

void RectangleImage::init()
{
	rect=owner->getRect();
}

void RectangleImage::activate()
{
	init();
	g->rendermanager->addToDraw(rect);
}

void RectangleImage::update()
{
	if(rect.x!=owner->getRect().x ||
		rect.y!=owner->getRect().y ||
		rect.w!=owner->getRect().w ||
		rect.h!=owner->getRect().h)
		activate();
}

void RectangleImage::desactivate()
{
	g->rendermanager->addToDraw(rect);
}

void RectangleImage::draw()
{
	boxRGBA(SDL_GetVideoSurface(),rect.x,rect.y,rect.w,rect.h,r,gr,b,a);
}

void RectangleImage::draw(SDL_Rect &upd)
{
	SDL_Rect draw=getRectCollision(upd,rect);

	printf("%d %d %u %u\n",draw.x,draw.y,draw.w,draw.h);
	boxRGBA(SDL_GetVideoSurface(),draw.x,draw.y,draw.w,draw.h,r,gr,b,a);
}
