#ifndef RENDERMANAGER_H
#define RENDERMANAGER_H

#define MAX_RECTS 20

#include <SDL.h>
#include <vector>

#include "actor.h"

using namespace std;


class Game;

class RenderManager
{
	public:
		RenderManager(Game *g);
		~RenderManager();

		void init(const int w,const int h,const int col);
		void update();
		void shutdown();

		void setBackground(const char* name);
		void setBackground(const string name){setBackground(name.c_str());}

		void draw();
		void drawAll();
		void drawDR();

		void addToDraw(const SDL_Rect &r);

		int w();
		int h();
		int d();

	protected:
		Game* game;
		SDL_Surface* screen;
		SDL_Surface* background;

		int width;
		int height;
		int depth;

		//Usado para dirty rectangle
		bool dirty_rectangle;
		SDL_Rect to_draw[MAX_RECTS];
		unsigned n_rects;
};

#endif
