#ifndef SPRITE_H
#define SPRITE_H

#include <SDL.h>
#include <string>

using namespace std;

#include "actorgraphic.h"

class Sprite : public ActorGraphic
{
	public:
		Sprite(Actor *aowner,string n):ActorGraphic(aowner),img(NULL),name(n){}
		~Sprite(){SDL_FreeSurface(img);}
		
		void init();
		void activate();
		void update();
		void desactivate();

		void draw();
		void draw(SDL_Rect &r);
		unsigned get_w()const{return img->w/num_frames;}
		unsigned get_h()const{return img->h;}

		void setMaxTick(const unsigned a){max_tick=a;}
		void setNumFrames(const unsigned n){num_frames=n;}
		
	protected:
		SDL_Surface *img;
		string name;

		unsigned actual_tick;
		unsigned max_tick;
		unsigned actual_frame;
		unsigned num_frames;
};

#endif
