#include <SDL.h>

#include <string>

using namespace std;

#include "boxactor.h"
#include "actorgraphic.h"
#include "rendermanager.h"
#include "textimage.h"

TextImage::TextImage(Actor *a,Text *t,string nf,const unsigned s):Image(a,nf),
	text((Text*)t),size(s),style(BLENDED),alignment(CENTER)
{
	SDL_Color c={255,255,255,0};
	fontcolor=c;
	SDL_Color b={0,0,0,255};
	background=b;
}
void TextImage::init()
{
	font=g->fontmanager->loadTTF(name,size);
}

void TextImage::activate()
{
	if(img!=NULL)
		SDL_FreeSurface(img);

	updateIMG();
	updatePOS();
	g->rendermanager->addToDraw(rect);
	change=false;
	center=owner->getCenter();
}

void TextImage::update()
{
	//Si cambia el texto
	if(text->isChange() || change || center!=owner->getCenter())
	{
		SDL_Rect r=owner->getRect();
		g->rendermanager->addToDraw(rect);
		SDL_FreeSurface(img);
		updateIMG();
		updatePOS();
		g->rendermanager->addToDraw(rect);
		change=false;
		center=owner->getCenter();
	}
}

void TextImage::setSize(unsigned s)
{
	size=s;
	init();
	change=true;
}
	
void TextImage::updateIMG()
{
	if(style==BLENDED)
		img=g->fontmanager->getTextBlended(text->getText(),font,fontcolor);

	else if(style==SHADED)
		img=g->fontmanager->getTextShaded(text->getText(),font,fontcolor,background);

	else
		img=g->fontmanager->getTextSolid(text->getText(),font,fontcolor);
}

void TextImage::updatePOS()
{
	rect.w=img->w;
	rect.h=img->h;
	rect.y=owner->getPos().scale_y()+(((BoxActor*)(owner))->getSize().scale_y()-img->h)/2;

	if(alignment==LEFT)
		rect.x=owner->getPos().scale_x();

	else if(alignment==CENTER)
		rect.x=owner->getPos().scale_x()+(((BoxActor*)(owner))->getSize().scale_x()-img->w)/2;

	else
		rect.x=owner->getPos().scale_x()+((BoxActor*)(owner))->getSize().scale_x()-img->w;
}
