#ifndef TIMEMANAGER_H
#define TIMEMANAGER_H

#include <SDL.h>
#include "game.h"

#include <list>

class Timer;

//Clase que se encarga del tiempo del juego, haciendo que sea constante
//en ordenadores de distinta potencia
class TimeManager
{
	public:
		TimeManager(Game *g);
		~TimeManager();

		void init(int atimetick);
		void update();
		void shutdown();

		void addTimer(Timer* t);
		void delTimer(Timer* t);

		bool isLogictick();
		bool isGraphictick();

		unsigned ticksPerSecond()const{return 1000/timetick;}
		float getTimeTick()const{return (float)timetick/1000;}
		void reset(){logic_tick=tick;}

	protected:
		Uint32 static tickCount(Uint32 interval,void *parameter);

		static volatile unsigned long tick;
		unsigned long time;
		unsigned timetick;
		unsigned frameskip,max_frameskip;
		unsigned totalframeskip;
		unsigned long logic_tick,old_tick;
		unsigned int max_fps,graphic_tick;
		SDL_TimerID timerID;
		std::list<Timer*> timers;
		std::list<Timer*> to_del;

		Game *game;
};

#endif
