#ifndef TIMER_H
#define TIMER_H

#define DECREASING false
#define INCREASING true

#include "timemanager.h"

class Timer
{
	public:
		Timer():time(0.0),growing(DECREASING){}
		~Timer(){shutdown();}

		//Inicializamos como contador o cuenta atras
		void start();
		void update();
		void countdown(const float at);

		//Anyadimos o restamos t al tiempo
		void setTime(const float at){time=at;}

		//Termina
		void shutdown(){t->delTimer(this);}

		//Obtiene el tiempo que queda o que lleva
		float getTime()const{return time;}
		int getSeconds()const{return (int)time%60;}
		int getMinutes()const{return (int)time/60;}

		//Con resume seguimos por donde ibamos
		void resume(){t->addTimer(this);}
		bool isEnd(){return time<=0;}

		static void setTimeManager(TimeManager* at){t=at;}

	private:
		float time;
		bool growing;
		static TimeManager* t;
};

#endif
